package com.jpsoft.shinestar.config;

import lombok.Data;
import lombok.Getter;
import lombok.Setter;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @author 墨鱼_mo
 * @date 2020-4-1 11:47
 */
@Component
@ConfigurationProperties(prefix = "wx.cp")
@Data
public class WxCpConfig {

    /**
     * 设置微信企业号的corpId
     */
    private String corpId;

    private List<AppConfig> appConfigs;


    @Getter
    @Setter
    public static class AppConfig {
        /**
         * 设置微信企业应用的AgentId
         */
        private Integer agentId;

        /**
         * 设置微信企业应用的Secret
         */
        private String secret;

        /**
         * 设置微信企业号的token
         */
        private String token;

        /**
         * 设置微信企业号的EncodingAESKey
         */
        private String aesKey;

    }





}
