package com.jpsoft.shinestar.modules.base.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
  描述:base_application_examine的实体类
 */
@Data
@ApiModel(value = "base_application_examine的实体类")
public class ApplicationExamineDTO {
    @ApiModelProperty(value = "")
    private String id;
    @ApiModelProperty(value = "申请者角色id")
    private String applicationRoleId;
    @ApiModelProperty(value = "申请者角色名称")
    private String applicationRoleName;
    @ApiModelProperty(value = "申请者公司id")
    private String applicationCompanyId;
    @ApiModelProperty(value = "申请者公司名称")
    private String applicationCompanyName;
    @ApiModelProperty(value = "审核人角色id")
    private String examineRoleId;
    @ApiModelProperty(value = "审核人角色名称")
    private String examineRoleName;
    @ApiModelProperty(value = "审核人公司id")
    private String examineCompanyId;
    @ApiModelProperty(value = "审核人公司名称")
    private String examineCompanyName;
    @ApiModelProperty(value = "是否删除")
    private Boolean delFlag;
    @ApiModelProperty(value = "创建人")
    private String createBy;
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    @ApiModelProperty(value = "更新人")
    private String updateBy;
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;
    @ApiModelProperty(value = "备注信息")
    private String remark;
    @ApiModelProperty(value = "审批等级")
    private Integer level;
    @ApiModelProperty(value = "审批类型(字典1:外出,2:休假,3:出差)")
    private String type;
    @ApiModelProperty(value = "审批类型(字典1:外出,2:休假,3:出差)")
    private String typeName;
    @ApiModelProperty(value = "请假天数")
    private Integer days;
    @ApiModelProperty(value = "包括下级单位")
    private Boolean includeSubordinate;
}