package com.jpsoft.shinestar.modules.base.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.util.Date;

@Data
public class CanteenDiningRecordDTO {

    @ApiModelProperty(value = "ID")
    private String id;

    @ApiModelProperty(value = "就餐金额")
    private BigDecimal categoryAmount;

    @ApiModelProperty(value = "就餐类别(1-早餐-2中餐-3晚餐)")
    private String categoryN;

    @ApiModelProperty(value = "记录时间")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    private Date recordTime;

    @ApiModelProperty(value = "备注")
    private String remark;

    @ApiModelProperty(value = "是否外协人员")
    private Boolean isOutsourcer;
}
