package com.jpsoft.shinestar.modules.base.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.util.Date;

@Data
public class CanteenOutsourcerBalanceDTO {
    @ApiModelProperty(value = "")
    private String id;
    @ApiModelProperty(value = "部门")
    private String companyName;
    @ApiModelProperty(value = "人员ID")
    private Long personId;
    @ApiModelProperty(value = "姓名")
    private String personName;
    @ApiModelProperty(value = "工号")
    private String jobNumber;
    @ApiModelProperty(value = "卡号")
    private String cardNumber;
    @ApiModelProperty(value = "剩余金额")
    private BigDecimal balanceFee;

    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "上次充值时间")
    private Date lastRechargeTime;

    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "上次就餐时间")
    private Date lastMealTime;


    @ApiModelProperty(value = "就餐次数")
    private Integer eatIndex;
}
