package com.jpsoft.shinestar.modules.base.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

@Data
public class InformationDTO {

    @ApiModelProperty(value = "id")
    private String id;

    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;

    @ApiModelProperty(value = "状态，0待回复/1已回复/2已结束")
    private String status;

    @ApiModelProperty(value = "状态（中文）")
    private String statusN;

    @ApiModelProperty(value = "提交内容")
    private String content;

    @ApiModelProperty(value = "回复内容")
    private String returnContent;

    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "回复时间")
    private Date returnTime;

    @ApiModelProperty(value = "房号")
    private String community;

    @ApiModelProperty(value = "提交人姓名")
    private String name;

    @ApiModelProperty(value = "提交人电话")
    private String phone;

    @ApiModelProperty(value = "图片")
    private String img;

    @ApiModelProperty(value = "投诉建议及报事报修类别")
    private int category;

    @ApiModelProperty(value = "类别（中文）")
    private String categoryN;
}
