package com.jpsoft.shinestar.modules.base.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.util.Date;

@Data
public class OrderDTO {
    private String id;

    private BigDecimal totalFee;

    private String goodsId;

    @ApiModelProperty(value = "商品标题")
    private String goodName;

    @ApiModelProperty(value = "学生姓名")
    private String name;

    @ApiModelProperty(value = "单位")
    private String companyName;

    @ApiModelProperty(value = "商品类型")
    private String goodTypeName;

    @ApiModelProperty(value = "商品数量")
    private String goodNum;

    @ApiModelProperty(value = "费用")
    private BigDecimal cost;

    @ApiModelProperty(value = "支付金额")
    private BigDecimal payFee;

    @ApiModelProperty(value = "支付方式")
    private String payName;
    @ApiModelProperty(value = "支付方式")
    private String payNameStr;

    @ApiModelProperty(value = "系统订单号")
    private String outOrderNo;

    @ApiModelProperty(value = "交易流水号")
    private String transactionId;

    @ApiModelProperty(value = "支付时间")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    private Date payTime;

    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;


    @ApiModelProperty(value = "订单状态")
    private String status;

    @ApiModelProperty(value = "支付状态")
    private Integer payStatus;

    @ApiModelProperty(value = "支付状态")
    private String payStatusStr;

    @ApiModelProperty(value = "联系电话")
    private String contactPhone;

    private String type;

    private String iconPic;

    private String month;

    private String color;



}
