package com.jpsoft.shinestar.modules.base.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.util.Date;

@Data
public class ParkingRecordDTO {
    private String id;

    @ApiModelProperty(value = "车牌号码")
    private String carNum;

    @ApiModelProperty(value = "所属物业")
    private String companyName;

    @ApiModelProperty(value = "车辆类型")
    private String carType;

    @ApiModelProperty(value = "累计时长")
    private BigDecimal parkingTime;

    @ApiModelProperty(value = "应收费用")
    private BigDecimal totalAmount;

    @ApiModelProperty(value = "优惠金额")
    private BigDecimal reduceAmount;

    @ApiModelProperty(value = "实收费用")
    private BigDecimal payAmount;

    @ApiModelProperty(value = "缴费时间")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    private Date paymentTime;

    @ApiModelProperty(value = "支付方式")
    private String payType;
}
