package com.jpsoft.shinestar.modules.base.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @author 墨鱼_mo
 * @date 2020-3-23 11:34
 */
@Data
public class PersonDeviceLogDTO {
    @ApiModelProperty(value = "ID")
    private String id;
    @ApiModelProperty(value = "设备序列号")
    private String deviceNo;
    @ApiModelProperty(value = "设备名称")
    private String deviceName;
    @ApiModelProperty(value = "人员id")
    private Integer personId;
    @ApiModelProperty(value = "人员名称")
    private String personName;
    @ApiModelProperty(value = "记录温度")
    private BigDecimal temperature;
    @ApiModelProperty(value = "匹配状态")
    private Integer matchStatus;
    @ApiModelProperty(value = "匹配信息")
    private String  matchMsg;
    @ApiModelProperty(value = "匹配人脸 ID")
    private Integer  matchFaceId;
    @ApiModelProperty(value = "图片地址")
    private String faceImage;
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "记录时间")
    private Date recordTime;
    @ApiModelProperty(value = "是否删除")
    private Boolean delFlag;
    @ApiModelProperty(value = "创建人")
    private String createBy;
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    @ApiModelProperty(value = "更新人")
    private String  updateBy;
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;
    @ApiModelProperty(value = "温度是否正常")
    private Boolean fever;

}
