package com.jpsoft.shinestar.modules.base.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.jpsoft.shinestar.modules.base.entity.PersonHealthLedger;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

@Data
public class PersonInfoDTO {
    @ApiModelProperty(value = "编号")
    private Long id;
    @ApiModelProperty(value = "企业编号")
    private String companyId;
    @ApiModelProperty(value = "企业名称")
    private String companyName;
    @ApiModelProperty(value = "姓名")
    private String name;
    @ApiModelProperty(value = "手机号")
    private String phone;
    @ApiModelProperty(value = "身份证号")
    private String idCard;
    @ApiModelProperty(value = "微信openId")
    private String openId;
    @ApiModelProperty(value = "人脸")
    private Boolean faceEnabled;
    @ApiModelProperty(value = "是否已将人脸信息传给终端")
    private Boolean faceBound;
    @ApiModelProperty(value = "刷卡")
    private Boolean cardEnabled;
    @ApiModelProperty(value = "手机")
    private Boolean appEnabled;
    @ApiModelProperty(value = "密码")
    private Boolean passwordEnabled;
    @ApiModelProperty(value = "访客")
    private Boolean guestEnabled;
    @ApiModelProperty(value = "微信通知是否开启")
    private Boolean wechatNoticeEnabled;
    @ApiModelProperty(value = "位置1")
    private String position1;
    @ApiModelProperty(value = "位置2")
    private String position2;
    @ApiModelProperty(value = "位置3")
    private String position3;
    @ApiModelProperty(value = "位置4")
    private String position4;
    @ApiModelProperty(value = "位置5")
    private String position5;
    @ApiModelProperty(value = "是否删除")
    private Boolean delFlag;
    @ApiModelProperty(value = "创建人")
    private String createBy;
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    @ApiModelProperty(value = "更新人")
    private String updateBy;
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;
    @ApiModelProperty(value = "人脸相片地址")
    private String faceImageUrl;
    @ApiModelProperty(value="权限（1-个人用户，2-企业管理员）")
    private String popedom;
    @ApiModelProperty(value="权限翻译")
    private String popedomName;
    @ApiModelProperty(value="设备")
    private String deviceName;
    @ApiModelProperty(value="单位性质")
    private String companyType;
    @ApiModelProperty(value = "园区ID")
    private String parkId;
    @ApiModelProperty(value = "园区")
    private String parkName;
    @ApiModelProperty(value = "所拥有的公司角色名称")
    private String mechanism;
    @ApiModelProperty(value="工作状态:1-工作，2-外出，3-出差，4-休假")
    private String workStatus;
    @ApiModelProperty(value="是否上传健康报告")
    private Boolean isUpHealth;
    @ApiModelProperty(value="健康报告")
    private PersonHealthLedger personHealthLedger;
    @ApiModelProperty(value="健康码")
    private String healthyCode;
    private String jobNumber;
    private String carNum;
}
