package com.jpsoft.shinestar.modules.base.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * @author 墨鱼_mo
 * @date 2021-1-23 11:00
 */
@Data
public class ReturnInfoDTO {

    private String id;

    private String name;

    private Integer sex;

    private String idCard;

    private String phone;

    @ApiModelProperty(value = "居住地区id")
    private String liveRegionId;
    @ApiModelProperty(value = "居住地详细地址")
    private String liveDetailAddress;

    private String type;

    @ApiModelProperty(value = "始发地")
    private String originId;
    @ApiModelProperty(value = "始发地详细地址")
    private String originDetailAddress;

    @ApiModelProperty(value = "途径地")
    private String avenuePlace;

    @ApiModelProperty(value = "交通工具")
    private String vehicle;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @ApiModelProperty(value = "返乡时间")
    private Date arriveTime;

    @ApiModelProperty(value = "7日阴性核酸检测")
    private Boolean haveCheck;
    @ApiModelProperty(value = "备注")
    private String remark;
    @ApiModelProperty(value = "核酸检测报告图片")
    private String checkImageUrl;
    @ApiModelProperty(value = "行程卡图片")
    private String travelImageUrl;
    @ApiModelProperty(value = "健康码图片")
    private String healthCodeUrl;

    private Boolean newFlag;
}
