package com.jpsoft.shinestar.modules.base.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

@Data
@ApiModel(value = "加班统计")
public class WorkOverStatistics {

    @ApiModelProperty(value = "用户ID")
    private Long personId;
    @ApiModelProperty(value = "部门")
    private String companyId;
    @ApiModelProperty(value = "部门")
    private String companyName;
    @ApiModelProperty(value = "工号")
    private String jobNumber;
    @ApiModelProperty(value = "姓名")
    private String personName;
    @ApiModelProperty(value = "加班时长")
    private Integer duration;
    @ApiModelProperty(value = "加班时长")
    private String durationStr;
    @ApiModelProperty(value = "加班申请次数")
    private Integer count;
    @ApiModelProperty(value = "审核通过次数")
    private Integer approvalCount;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @ApiModelProperty(value = "最后申请时间")
    private Date lastCreateTime;
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @ApiModelProperty(value = "最后核对时间")
    private Date lastApprovalTime;

}