package com.jpsoft.shinestar.modules.base.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;

import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
 * 描述:base_application_examine的实体类
 */
@Data
@ApiModel(value = "base_application_examine的实体类")
public class ApplicationExamine {
    @ApiModelProperty(value = "")
    private String id;
    @ApiModelProperty(value = "申请者角色id")
    private String applicationRoleId;
    @ApiModelProperty(value = "申请者公司id")
    private String applicationCompanyId;
    @ApiModelProperty(value = "审核人角色id")
    private String examineRoleId;
    @ApiModelProperty(value = "审核人公司id")
    private String examineCompanyId;
    @ApiModelProperty(value = "越级审核人角色")
    private String skipExamineRoleId;
    @ApiModelProperty(value = "越级审核人公司")
    private String skipExamineCompanyId;
    @ApiModelProperty(value = "是否删除")
    private Boolean delFlag;
    @ApiModelProperty(value = "创建人")
    private String createBy;
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    @ApiModelProperty(value = "更新人")
    private String updateBy;
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;
    @ApiModelProperty(value = "备注信息")
    private String remark;
    @ApiModelProperty(value = "审批等级")
    private Integer level;
    @ApiModelProperty(value = "审批类型(字典1:外出,2:休假,3:出差)")
    private String type;
    @ApiModelProperty(value = "请假天数")
    private Integer days;
    @ApiModelProperty(value = "包括下级")
    private Boolean includeSubordinate;
}