package com.jpsoft.shinestar.modules.base.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;
import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
  描述:base_approval_config的实体类
 */
@Data
@ApiModel(value = "base_approval_config的实体类")
public class ApprovalConfig {
    @ApiModelProperty(value = "")
    private String id;
    @ApiModelProperty(value = "公司id")
    private String companyId;
    @ApiModelProperty(value = "公司名称")
    private String companyName;
    @ApiModelProperty(value = "类型（1：补卡，2：外出，3：出差，4：休假，5：加班：7：年假）")
    private String type;
    @ApiModelProperty(value = "类型翻译")
    private String typeN;
    @ApiModelProperty(value = "审批需要的层级")
    private String level;
    @ApiModelProperty(value = "申请时对应的天数")
    private String days;
    @ApiModelProperty(value = "是否删除")
    private Boolean delFlag;
    @ApiModelProperty(value = "创建人")
    private String createBy;
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    @ApiModelProperty(value = "更新人")
    private String updateBy;
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;
    @ApiModelProperty(value = "备注信息")
    private String remark;
}