package com.jpsoft.shinestar.modules.base.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * 描述:base_camera_info的实体类
 */
@Data
@ApiModel(value = "base_camera_info的实体类")
public class CameraInfo {
    /**
     * 主键
     */
    @ApiModelProperty(value = "主键")
    private String id;
    /**
     * 设备序列号,存在英文字母的设备序列号，字母需为大写
     */
    @ApiModelProperty(value = "设备序列号,存在英文字母的设备序列号，字母需为大写")
    private String deviceSerial;
    /**
     * 通道号
     */
    @ApiModelProperty(value = "通道号")
    private Integer channelNo;
    /**
     * 设备名称
     */
    @ApiModelProperty(value = "设备名称")
    private String deviceName;
    /**
     * 在线状态：0-不在线，1-在线
     */
    @ApiModelProperty(value = "在线状态：0-不在线，1-在线")
    private Integer status;
    /**
     * 验证码
     */
    @ApiModelProperty(value = "验证码")
    private String validCode;
    /**
     * 单位编号
     */
    @ApiModelProperty(value = "单位编号")
    private String companyId;
    /**
     * 设备版本
     */
    @ApiModelProperty(value = "设备版本")
    private String deviceVersion;
    /**
     * 是否删除
     */
    @ApiModelProperty(value = "是否删除")
    private Boolean delFlag;
    /**
     * 创建人
     */
    @ApiModelProperty(value = "创建人")
    private String createBy;
    /**
     * 创建时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 更新人
     */
    @ApiModelProperty(value = "更新人")
    private String updateBy;
    /**
     * 更新时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;

    /**
     * 单位名称
     */
    @ApiModelProperty(value = "单位名称")
    private String companyName;

    @ApiModelProperty(value = "截图地址")
    private String picUrl;

    @ApiModelProperty(value = "房间地址")
    private String roomAddress;

    @ApiModelProperty(value = "摄像头分类（1-试用，2-付费）")
    private String classify;


    @ApiModelProperty(value = "人员ID")
    private Long personId;

    @ApiModelProperty(value = "订单ID")
    private String orderId;

    @ApiModelProperty(value = "账号")
    private String account;

    @ApiModelProperty(value = "密码")
    private String password;

    @ApiModelProperty(value = "联系电话")
    private String contactPhone;

    @ApiModelProperty(value = "所属平台(ys-莹石云，aliyun-阿里云)")
    private String platform;

    @ApiModelProperty(value = "平台名称")
    private String platformN;
}