package com.jpsoft.shinestar.modules.base.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;
import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
  描述:base_canteen_dining_record的实体类
 */
@Data
@ApiModel(value = "base_canteen_dining_record的实体类")
public class CanteenDiningRecord {
        @ApiModelProperty(value = "")
    private String id;
        @ApiModelProperty(value = "人员编号")
    private Long personId;
        @ApiModelProperty(value = "设备序列号")
    private String deviceNo;
        @ApiModelProperty(value = "是否外协人员")
    private Boolean isOutsourcer;
        @ApiModelProperty(value = "就餐类别(1-早餐-2中餐-3晚餐)")
    private String category;
        @ApiModelProperty(value = "就餐金额")
    private BigDecimal categoryAmount;
        @ApiModelProperty(value = "就餐地点")
    private String address;
        @ApiModelProperty(value = "是否删除")
    private Boolean delFlag;
        @ApiModelProperty(value = "创建人")
    private String createBy;
        @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "创建时间")
    private Date createTime;
        @ApiModelProperty(value = "更新人")
    private String updateBy;
        @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "更新时间")
    private Date updateTime;

    @ApiModelProperty(value = "部门")
    private String companyName;
    @ApiModelProperty(value = "姓名")
    private String personName;
    @ApiModelProperty(value = "工号")
    private String jobNumber;

    @ApiModelProperty(value = "就餐类别(1-早餐-2中餐-3晚餐)")
    private String categoryName;

    @ApiModelProperty(value = "就餐日期")
    private String attendanceDate;

    @ApiModelProperty(value = "记录时间")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    private Date recordTime;

    @ApiModelProperty(value = "备注")
    private String remark;

}