package com.jpsoft.shinestar.modules.base.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
  描述:base_canteen_info的实体类
 */

@Data
@ApiModel(value = "base_canteen_info的实体类")
public class CanteenInfo {

	@ApiModelProperty(value = "ID")
	private String id;

	@ApiModelProperty(value = "食堂名称")
	private String name;

	@ApiModelProperty(value = "食堂位置")
	private String address;

	@ApiModelProperty(value = "午餐时间")
	private String lunchTime;

	@ApiModelProperty(value = "午餐金额")
	private BigDecimal lunchFee;

	@ApiModelProperty(value = "晚餐时间")
	private String dinnerTime;

	@ApiModelProperty(value = "晚餐金额")
	private BigDecimal dinnerFee;

	@ApiModelProperty(value = "宵夜时间")
	private String midnightTime;

	@ApiModelProperty(value = "宵夜金额")
	private BigDecimal midnightFee;

	@ApiModelProperty(value = "是否删除")
	private Boolean delFlag;
	/**
	 *创建人
	 */
	@ApiModelProperty(value = "创建人")
	private String createBy;
	/**
	 *创建时间
	 */
	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	@ApiModelProperty(value = "创建时间")
	private Date createTime;
	/**
	 *更新人
	 */
	@ApiModelProperty(value = "更新人")
	private String updateBy;
	/**
	 *更新时间
	 */
	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	@ApiModelProperty(value = "更新时间")
	private Date updateTime;


	@ApiModelProperty(value = "午餐时间范围（用于显示）")
	private String lunchTimeRange;

	@ApiModelProperty(value = "晚餐时间范围（用于显示）")
	private String dinnerTimeRange;

	@ApiModelProperty(value = "宵夜时间范围（用于显示）")
	private String midnightTimeRange;


	List<CanteenDining> canteenDiningList;


	Map<String,List<String>> canteenDiningMap;

	Map<String,Object> canteenDiningObjMap;

}