package com.jpsoft.shinestar.modules.base.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;
import java.util.List;

import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
 * 描述:base_checkin_info的实体类
 */
@Data
@ApiModel(value = "base_checkin_info的实体类")
public class CheckinInfo {
    @ApiModelProperty(value = "编号")
    private String id;
    @ApiModelProperty(value = "楼栋")
    private String building;
    @ApiModelProperty(value = "房号")
    private String room;
    @ApiModelProperty(value = "企业名称")
    private String companyId;
    private String companyName;
    @ApiModelProperty(value = "联系人")
    private Long artificialPerson;
    private String artificialPersonN;
    @ApiModelProperty(value = "联系电话")
    private String artificialPersonPhone;
    @ApiModelProperty(value = "面积")
    private String area;
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @ApiModelProperty(value = "入驻时间")
    private Date checkinTime;
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @ApiModelProperty(value = "费用到期时间")
    private Date feeExpirationTime;
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @ApiModelProperty(value = "合同到期时间")
    private Date contractExpirationTime;
    @ApiModelProperty(value = "租赁期限")
    private String leaseTerm;
    @ApiModelProperty(value = "--")
    private String rent;
    @ApiModelProperty(value = "物业编号")
    private String propertyId;
    @ApiModelProperty(value = "是否删除")
    private Boolean delFlag;
    @ApiModelProperty(value = "创建人")
    private String createBy;
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    @ApiModelProperty(value = "更新人")
    private String updateBy;
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;
    @ApiModelProperty(value = "法人")
    private String boss;
    @ApiModelProperty(value = "是否开启微信支付")
    private Boolean wechatPay;
    @ApiModelProperty(value = "是否开启支付宝")
    private Boolean aliPay;
}