package com.jpsoft.shinestar.modules.base.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
  描述:base_company_info的实体类
 */
@Data
@ApiModel(value = "base_company_info的实体类")
public class CompanyInfo {
    @ApiModelProperty(value = "公司编号")
	private String id;
	@ApiModelProperty(value = "公司logo")
	private String logo;
	@ApiModelProperty(value = "层级")
	private Integer level;
    @ApiModelProperty(value = "序号")
	private Integer sortNo;
    @ApiModelProperty(value = "公司名称")
	private String name;
	@ApiModelProperty(value = "公司全称")
	private String fullName;
    @ApiModelProperty(value = "备注")
	private String remark;
    @ApiModelProperty(value = "创建人")
	private String createBy;
	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "创建时间")
	private Date createTime;
    @ApiModelProperty(value = "更新人")
	private String updateBy;
	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "更新时间")
	private Date updateTime;
    @ApiModelProperty(value = "是否删除")
	private Boolean delFlag;
	@ApiModelProperty(value = "上级公司")
	private String parentId;
	@ApiModelProperty(value = "企业编码")
	private String code;
	@ApiModelProperty(value = "上级单位")
	private String parentName;
	@ApiModelProperty(value = "单位性质")
	private String type;
	@ApiModelProperty(value = "单位性质翻译")
	private String typeName;
	@ApiModelProperty(value = "大屏公示墙网址")
	private String wallUrl;
	@ApiModelProperty(value = "场景ID")
	private String sceneId;
	@ApiModelProperty(value = "地区id")
	private String regionId;
	@ApiModelProperty(value = "场景值翻译")
	private String sceneName;
	@ApiModelProperty(value = "地区翻译")
	private String regionName;
	@ApiModelProperty(value = "关联公司")
	private String relationCompanyId;
	@ApiModelProperty(value = "是否允许注册新用户")
	private Boolean enableRegister;
	@ApiModelProperty(value = "单位类型/字典:公司,部门等")
	private String unitType;
	@ApiModelProperty(value = "是否有下级")
	private Boolean hasNext;
	@ApiModelProperty(value = "是否能开启手机支付")
	private Boolean isMobilePayment;

	@ApiModelProperty(value = "健康上报提醒开关")
	private Boolean healthyReportNoticeEnable;

	@ApiModelProperty(value = "健康上报提醒时间")
	private String healthyReportNoticeTime;

	@ApiModelProperty(value = "健康上报时间")
	private String healthyReportSubmitTime;

	@ApiModelProperty(value = "是否外协部门")
	private Boolean isOutsourcer;

	@ApiModelProperty(value = "单位分类/后勤查询专用")
	private String classify;
}