package com.jpsoft.shinestar.modules.base.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * @author 墨鱼_mo
 * @date 2020-4-14 9:33
 */
@Data
@ApiModel(value = "base_company_payment_info的实体类")
public class CompanyPaymentInfo {


    private Long id;
    private String companyId;
    private String companyName;
    private String parkingWechatNotifyUrl;
    private String parkingAlipayNotifyUrl;
    private String appId;
    private String mchId;
    private String subAppId;
    private String subAppSecret;
    private String subMchId;
    private String appAuthToken;
    private String createBy;
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    private Date createTime;
    private String updateBy;
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    private Date updateTime;
    private Boolean delFlag;
    private String name;
    private String cycle;//结算周期
    private Boolean isOpenWechat;
    private Boolean isOpenAlipay;

    @ApiModelProperty(value = "开户名称")
    private String bankName;

    @ApiModelProperty(value = "银行")
    private String bank;

    @ApiModelProperty(value = "银行账号")
    private String account;

    @ApiModelProperty(value = "是否默认")
    private Boolean isDefault;

    @ApiModelProperty(value = "关联的财务人员ID")
    private Long financePersonId;

    @ApiModelProperty(value = "关联的后端财务人员ID")
    private String financeUserId;

}
