package com.jpsoft.shinestar.modules.base.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;

import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
 * 描述:base_company_supervise的实体类
 */
@Data
@ApiModel(value = "base_company_supervise的实体类")
public class CompanySupervise {
    @ApiModelProperty(value = "")
    private String id;
    @ApiModelProperty(value = "公司id")
    private String companyId;
    @ApiModelProperty(value = "公司总人数")
    private Integer totalNum;
    @ApiModelProperty(value = "公司已测人员")
    private Integer totalCheckNum;
    @ApiModelProperty(value = "异常人数")
    private Integer totalAbnormalNum;
    @ApiModelProperty(value = "离荆人数")
    private Integer leaveNum;
    @ApiModelProperty(value = "检测率")
    private String testRate;
    @ApiModelProperty(value = "记录时间")
    private String recordTime;
    @ApiModelProperty(value = "是否删除")
    private Boolean delFlag;
    @ApiModelProperty(value = "创建人")
    private String createBy;
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    @ApiModelProperty(value = "更新人")
    private String updateBy;
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;

    @ApiModelProperty(value = "省外在荆州过年人数")
    private Integer atOutProvinceNum = 0;
    @ApiModelProperty(value = "省内在荆州过年人数")
    private Integer atProvinceNum = 0;
}