package com.jpsoft.shinestar.modules.base.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @author 墨鱼_mo
 * @date 2021-5-24 13:55
 */
@Data
public class CustomerDiningRecord {

    @ApiModelProperty(value = "编号")
    private String id;

    @ApiModelProperty(value = "人员身份ID")
    private String personPopedomId;

    @ApiModelProperty(value = "接待公司")
    private String companyId;

    @ApiModelProperty(value = "客户单位")
    private String customerCompany;

    @ApiModelProperty(value = "事由")
    private String reason;

    @ApiModelProperty(value = "客户人数")
    private Integer customerNum;

    @ApiModelProperty(value = "陪同人数")
    private Integer accompanyNum;

    @ApiModelProperty(value = "就餐时间")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    private Date diningTime;

    @ApiModelProperty(value = "用餐安排")
    private String diningName;

    @ApiModelProperty(value = "用餐标准金额")
    private BigDecimal diningFee;

    @ApiModelProperty(value = "审核状态（0：审核中，1：同意，2：退回，3：拒绝，4：无需审核）")
    private String status;


    @ApiModelProperty(value = "创建人")
    private String createBy;

    @ApiModelProperty(value = "创建时间")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    private Date createTime;

    @ApiModelProperty(value = "更新人")
    private String updateBy;

    @ApiModelProperty(value = "更新时间")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    private Date updateTime;

    @ApiModelProperty(value = "是否删除")
    private Boolean delFlag = false;

    @ApiModelProperty(value = "流程实例编号")
    private String procinstId;


    private String personName;
    private String companyName;
    private String statusN;
}
