package com.jpsoft.shinestar.modules.base.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
  描述:base_device_role_person的实体类
 */
@Data
public class DeviceRolePerson {
	@ApiModelProperty(value = "ID")
	private String id;

	@ApiModelProperty(value = "角色或者人员ID")
	private String rolePersonId;

	@ApiModelProperty(value = "关联是角色还是人员（角色：0，人员：1）")
	private Integer rolePerson;

	@ApiModelProperty(value = "设备ID")
	private String deviceId;

	@ApiModelProperty(value = "是否限制次数")
	private Boolean checkOnCountFlag;

	@ApiModelProperty(value = "时间段内考勤次数,json数据（格式：{'come':'1','out':'1'}）")
	private String checkOnCount;

	@ApiModelProperty(value = "是否限制考勤时间")
	private Boolean checkOnTimeFlag;

	@ApiModelProperty(value = "考勤开始时间")
	private String checkStartTime;

	@ApiModelProperty(value = "考勤结束时间")
	private String checkEndTime;

	@ApiModelProperty(value = "是否删除")
	private Boolean delFlag;

	@ApiModelProperty(value = "创建人")
	private String createBy;

	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	@ApiModelProperty(value = "创建时间")
	private Date createTime;

	@ApiModelProperty(value = "更新人")
	private String updateBy;

	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	@ApiModelProperty(value = "更新时间")
	private Date updateTime;

}