package com.jpsoft.shinestar.modules.base.entity;

import java.io.Serializable;
import java.math.BigInteger;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
  描述:base_epidemic_report的实体类
 */
@Data
public class EpidemicReport {
	@ApiModelProperty(value = "编号")
	private String id;

	@ApiModelProperty(value = "人员ID")
	private Long personId;

	@ApiModelProperty(value = "联系方式")
	private String phone;

	@ApiModelProperty(value = "内容")
	private String content;

	@ApiModelProperty(value = "图片")
	private String img;

	@ApiModelProperty(value = "状态（0：上传失败/1：上传成功）")
	private String status;

	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
	@ApiModelProperty(value = "创建时间")
	private Date createTime;

	@ApiModelProperty(value = "创建人")
	private String createBy;

	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
	@ApiModelProperty(value = "更新时间")
	private Date updateTime;

	@ApiModelProperty(value = "更新人")
	private String updateBy;

	@ApiModelProperty(value = "是否删除")
	private Boolean delFlag;

}