package com.jpsoft.shinestar.modules.base.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * @author 墨鱼_mo
 * @date 2020-7-6 9:19
 */
@Data
public class GoodsInfo {

    @ApiModelProperty(value = "id")
    private String id;

    @ApiModelProperty(value = "名称")
    private String name;


    @ApiModelProperty(value = "描述")
    private String desc;

    @ApiModelProperty(value = "图片")
    private String pic;


    @ApiModelProperty(value = "费用")
    private BigDecimal cost;

    @ApiModelProperty(value = "类别（1：校车，2：保险）")
    private String type;


    /**
     * 创建人
     */
    @ApiModelProperty(value = "创建人")
    private String createBy;

    /**
     * 创建时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 更新人
     */
    @ApiModelProperty(value = "更新人")
    private String updateBy;
    /**
     * 更新时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;
    /**
     * 是否删除
     */
    @ApiModelProperty(value = "是否删除")
    private Boolean delFlag;

    @ApiModelProperty(value = "拓展字段1")
    private String expand1;

    @ApiModelProperty(value = "拓展字段2")
    private String expand2;

    @ApiModelProperty(value = "积分使用场景(字典):1充值2公告通知3发作业")
    private String scenes;
    @ApiModelProperty(value = "翻译")
    private String scenesName;

    @ApiModelProperty(value = "是否激活")
    private Boolean isActivation;

    @ApiModelProperty(value = "单价")
    private BigDecimal unitPrice;

    @ApiModelProperty(value = "单位")
    private String unit;

    @ApiModelProperty(value = "数量单位")
    private String numUnit;
}
