package com.jpsoft.shinestar.modules.base.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;
import java.util.List;

import com.jpsoft.shinestar.modules.base.dto.MeetingPersonDTO;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
  描述:base_meeting_info的实体类
 */
@Data
public class MeetingInfo {
	private String id;
	private String number;
	private String name;
	private String addressId;
	private String content;
	private String remark;
	private String status;
	private String pushStatus;

	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
	@ApiModelProperty(value = "推送时间")
	private Date pushTime;
	private String createBy;

	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
	@ApiModelProperty(value = "创建时间")
	private Date createTime;
	private String updateBy;

	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
	@ApiModelProperty(value = "更新时间")
	private Date updateTime;
	private Boolean delFlag;


	private List<String> meetingDateList;
	private List<String> meetingTimeList;
	private String addressName;
	private List<String> startSignInTimeList;
	private List<String> endSignInTimeList;
	private String createName;
	private String statusN;
	private String pushStatusN;

	private List<MeetingTime> meetingTimeDataList;
	private List<MeetingTime> removeMeetingTimeList;

	private String selectPersonKey;
	private List<MeetingPersonDTO> selectPersonDto;

	private String searchCompanyId;

	private String[] searchCompanyIds;
}