package com.jpsoft.shinestar.modules.base.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
  描述:base_message_notice的实体类
 */
@Data
@ApiModel(value = "base_message_notice的实体类")
public class MessageNotice {
	/**
	 *ID
	 */
        @ApiModelProperty(value = "ID")
	private String id;
	/**
	 *标题
	 */
        @ApiModelProperty(value = "标题")
	private String title;
	/**
	 *内容
	 */
        @ApiModelProperty(value = "内容")
	private String content;
	/**
	 *发件人ID
	 */
        @ApiModelProperty(value = "发件人ID")
	private String senderId;
	/**
	 *收件人ID
	 */
        @ApiModelProperty(value = "收件人ID")
	private String recipientId;
	/**
	 *状态(通过/未审核)
	 */
        @ApiModelProperty(value = "审核状态(通过/未审核)")
	private Boolean status;
	/**
	 *是否删除
	 */
        @ApiModelProperty(value = "是否删除")
	private Boolean delFlag;
	/**
	 *创建人
	 */
        @ApiModelProperty(value = "创建人")
	private String createBy;
	/**
	 *创建时间
	 */
    @DateTimeFormat(pattern="yyyy-MM-dd")
	@JsonFormat(pattern = "yyyy-MM-dd",timezone ="GMT+8")
	@ApiModelProperty(value = "创建时间")
	private Date createTime;
	/**
	 *更新人
	 */
        @ApiModelProperty(value = "更新人")
	private String updateBy;
	/**
	 *更新时间
	 */
    	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "更新时间")
	private Date updateTime;


	@ApiModelProperty(value="接收公司")
	private String noticeCompany;

	@ApiModelProperty(value="接收人员职位类型','号分割")
	private String noticeType;

	@ApiModelProperty(value="接收人员职位名称")
	private String noticeTypeN;

	@ApiModelProperty(value="是否")
	private String isClassTeacher;

	@ApiModelProperty(value="分类")
	private String classify;

	@ApiModelProperty(value="分类翻译")
	private String classifyN;

	@ApiModelProperty(value="积分")
	private int point;

	@ApiModelProperty(value="是否需要签字")
	private Boolean isSign;

	@ApiModelProperty(value="是否领取积分")
	private Boolean isReceive;
	@ApiModelProperty(value="类型:1站内通告,2微信")
	private String type;
	@ApiModelProperty(value="链接")
	private String noticeLink;
	@ApiModelProperty(value="是否已发送微信消息")
	private Boolean sendWechat;
	@ApiModelProperty(value="微信消息通知模板")
	private String wechatCode;
}