package com.jpsoft.shinestar.modules.base.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
  描述:base_message_report的实体类
 */
@Data
@ApiModel(value = "base_message_report的实体类")
public class MessageReport {
	/**
	 *ID
	 */
        @ApiModelProperty(value = "ID")
	private String id;
	/**
	 *标题
	 */
        @ApiModelProperty(value = "标题")
	private String title;
	/**
	 *内容
	 */
        @ApiModelProperty(value = "内容")
	private String content;
	/**
	 *发件人ID
	 */
        @ApiModelProperty(value = "发件人ID")
	private String senderId;
	/**
	 *收件人ID
	 */
        @ApiModelProperty(value = "收件人ID")
	private String recipientId;
	/**
	 *状态(未读/已读)
	 */
        @ApiModelProperty(value = "状态(未读/已读)")
	private Boolean status;
	/**
	 *是否删除
	 */
        @ApiModelProperty(value = "是否删除")
	private Boolean delFlag;
	/**
	 *创建人
	 */
        @ApiModelProperty(value = "创建人")
	private String createBy;
	/**
	 *创建时间
	 */
    	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "创建时间")
	private Date createTime;
	/**
	 *更新人
	 */
        @ApiModelProperty(value = "更新人")
	private String updateBy;
	/**
	 *更新时间
	 */
    	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "更新时间")
	private Date updateTime;

	@ApiModelProperty(value = "电话")
	private String phone;

	@ApiModelProperty(value = "照片")
	private String photo;
}