package com.jpsoft.shinestar.modules.base.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;

import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
 * 描述:base_message_send_condition的实体类
 */
@Data
@ApiModel(value = "base_message_send_condition的实体类")
public class MessageSendCondition {
    /**
     * 主键
     */
    @ApiModelProperty(value = "主键")
    private String id;
    /**
     * 消息编号
     */
    @ApiModelProperty(value = "消息编号")
    private String messageId;
    /**
     * 单位编号
     */
    @ApiModelProperty(value = "单位编号")
    private String companyId;
    /**
     * 包含下级单位
     */
    @ApiModelProperty(value = "包含下级单位")
    private Boolean includeChildren;
    /**
     * 单位机构编号
     */
    @ApiModelProperty(value = "单位机构编号")
    private String companyStructureId;
    /**
     * 人员角色编号
     */
    @ApiModelProperty(value = "人员角色编号")
    private String personRoleId;
    /**
     * 创建人
     */
    @ApiModelProperty(value = "创建人")
    private String createBy;
    /**
     * 创建时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 更新人
     */
    @ApiModelProperty(value = "更新人")
    private String updateBy;
    /**
     * 更新时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;

    /**
     * 是否删除
     */
    @ApiModelProperty(value = "是否删除")
    private Boolean delFlag;

    @ApiModelProperty(value = "企业名称")
    private String companyName;

    @ApiModelProperty(value = "所在部门")
    private String companyStructName;

    @ApiModelProperty(value = "所在单位角色")
    private String roleName;
}