package com.jpsoft.shinestar.modules.base.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * 描述:base_mobile_banner_info的实体类
 */
@Data
@ApiModel(value = "base_mobile_banner_info的实体类")
public class MobileBannerInfo {
    /**
     *
     */
    @ApiModelProperty(value = "")
    private String id;
    /**
     * 幻灯片标题
     */
    @ApiModelProperty(value = "幻灯片标题")
    private String name;
    /**
     * 幻灯片分类
     */
    @ApiModelProperty(value = "幻灯片分类")
    private String classify;
    /**
     * 幻灯片链接地址
     */
    @ApiModelProperty(value = "幻灯片链接地址")
    private String linkUrl;
    /**
     * 幻灯片图片
     */
    @ApiModelProperty(value = "幻灯片图片")
    private String picUrl;
    /**
     * 创建人
     */
    @ApiModelProperty(value = "创建人")
    private String createBy;
    /**
     * 创建时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 更新人
     */
    @ApiModelProperty(value = "更新人")
    private String updateBy;
    /**
     * 更新时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;
    /**
     * 是否删除
     */
    @ApiModelProperty(value = "是否删除")
    private Boolean delFlag;

    @ApiModelProperty(value = "幻灯片分类")
    private String classifyN;

    @ApiModelProperty(value = "审核状态(0-未审核，1-已审核)")
    private Boolean enabled;

    @ApiModelProperty(value = "序号")
    private Integer sortNo;

    @ApiModelProperty(value = "是否根据商品类别显示")
    private String goodsType;

    @ApiModelProperty(value = "是否是班主任专属")
    private Boolean isTeachers;



}