package com.jpsoft.shinestar.modules.base.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * @author 墨鱼_mo
 * @date 2020-7-27 9:10
 */
@Data
public class OrderLog {

    private String id;

    @ApiModelProperty(value = "订单id")
    private String orderId;


    @ApiModelProperty(value = "操作内容")
    private String content;

    /**
     *是否删除
     */
    @ApiModelProperty(value = "是否删除")
    private Boolean delFlag = false;
    /**
     *创建人
     */
    @ApiModelProperty(value = "创建人")
    private String createBy;
    /**
     *创建时间
     */
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     *更新人
     */
    @ApiModelProperty(value = "更新人")
    private String updateBy;
    /**
     *更新时间
     */
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;

    public OrderLog() {
    }

    public OrderLog(String orderId, String content, String createBy) {
        this.orderId = orderId;
        this.content = content;
        this.createBy = createBy;
    }
}
