package com.jpsoft.shinestar.modules.base.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;
import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
  描述:base_parking_coupon的实体类
  商户优惠卷
 */
@Data
@ApiModel(value = "base_parking_coupon的实体类")
public class ParkingCoupon {
        @ApiModelProperty(value = "")
    private String id;
        @ApiModelProperty(value = "商户id")
    private String merchantId;
    @ApiModelProperty(value = "商户名称")
    private String merchantName;
    @ApiModelProperty(value = "优惠券类型（3：时长减免券，4：全免券，5：金额减免券）")
    private String type;
    @ApiModelProperty(value = "优惠券类型（3：时长减免券，4：全免券，5：金额减免券）")
    private String typeName;
        @ApiModelProperty(value = "优惠额度")
    private Integer reduce;
        @ApiModelProperty(value = "停车记录id")
    private String parkingRecordId;
        @ApiModelProperty(value = "使用状态（0：未使用，1：使用）")
    private Boolean useStatus;
        @ApiModelProperty(value = "使用额度")
    private Integer useQuote;
        @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "使用时间")
    private Date useTime;
        @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "失效时间")
    private Date invalidTime;
        @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "核销时间")
    private Date verifyTime;
        @ApiModelProperty(value = "是否删除")
    private Boolean delFlag = false;
        @ApiModelProperty(value = "")
    private String createBy;
        @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "")
    private Date createTime;
        @ApiModelProperty(value = "")
    private String updateBy;
        @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "")
    private Date updateTime;
    private String companyId;
    private String companyName;
    //车牌号
    private String carNum;
    //进场时间
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    private Date inParkingTime;
    //出场时间
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    private Date outParkingTime;
}