package com.jpsoft.shinestar.modules.base.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;

import com.jpsoft.shinestar.modules.common.utils.TypeNameUtil;
import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
 * 描述:base_person_application_info的实体类
 */
@Data
@ApiModel(value = "base_person_application_info的实体类")
public class PersonApplicationInfo {
    @ApiModelProperty(value = "")
    private String id;
    @ApiModelProperty(value = "用户id")
    private Long personId;
    @ApiModelProperty(value = "申请人姓名")
    private String name;
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "申请时间")
    private Date applicantTime;
    @ApiModelProperty(value = "所申请的公司")
    private String companyId;
    @ApiModelProperty(value = "所申请的角色")
    private String personRoleId;
    @ApiModelProperty(value = "所申请的机构id")
    private String structureId;
    @ApiModelProperty(value = "所申请的机构名称")
    private String structureName;
    @ApiModelProperty(value = "申请的手机号")
    private String telephone;
    @ApiModelProperty(value = "申请的身份证号")
    private String idCard;
    @ApiModelProperty(value = "申请时提交的人脸")
    private String faceImageUrl;
    @ApiModelProperty(value = "申请时提交的地址")
    private String address;
    @ApiModelProperty(value = "场景id")
    private String sceneId;
    @ApiModelProperty(value = "区域id")
    private String regionId;
    @ApiModelProperty(value = "状态（0：待审核，1：同意，2：拒绝）")
    private String status;
    private String statusN;
    @ApiModelProperty(value = "审核人id")
    private String examinePopedomId;
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "审核时间")
    private Date examineTime;
    @ApiModelProperty(value = "备注")
    private String remark;
    @ApiModelProperty(value = "创建人")
    private String createBy;
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    @ApiModelProperty(value = "更新人")
    private String updateBy;
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;
    @ApiModelProperty(value = "是否删除")
    private Boolean delFlag;

    @ApiModelProperty(value = "场景名称")
    private String sceneName;
    @ApiModelProperty(value = "公司名称")
    private String companyName;
    @ApiModelProperty(value = "角色名称")
    private String personRoleName;
    @ApiModelProperty(value = "服务公司")
    private String serviceCompanyId;
    @ApiModelProperty(value = "推广者id")
    private Long popularizePersonId;
    @ApiModelProperty(value = "审核人姓名")
    private String examineName;
    @ApiModelProperty(value = "设备id是")
    private String deviceIds;
    @ApiModelProperty(value = "微信openId")
    private String openId;

    public String getStatusN(){
        String text = TypeNameUtil.getExamineTypeName(status);
        /*String statusN;
        if(status.equals("1")){
            statusN="同意";
        }
        else if(status.equals("2")){
            statusN="拒绝";
        }
        else{
            statusN="待审核";
        }*/
        return text;
    }
}