package com.jpsoft.shinestar.modules.base.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @author 墨鱼_mo
 * @date 2020-3-15 13:30
 */
@Data
@ApiModel(value = "base_person_device_log的实体类")
public class PersonDeviceLog {

    /**
     * 主体id
     */
    @ApiModelProperty(value = "ID")
    private String id;

    /**
     * 设备序列号
     */
    @ApiModelProperty(value = "设备序列号")
    private String deviceNo;

    @ApiModelProperty(value = "设备信息")
    private DeviceInfo device;


    /**
     * 人员id
     */
    @ApiModelProperty(value = "人员id")
    private Long personId;

    /**
     * 人员姓名
     */
    @ApiModelProperty(value = "人员姓名")
    private String personName;

    @ApiModelProperty(value = "人员信息")
    private PersonInfo person;

    /**
     * 记录温度
     */
    @ApiModelProperty(value = "记录温度")
    private BigDecimal temperature;

    /**
     * 验证号码
     */
    @ApiModelProperty(value = "验证号码")
    private String identityNo;


    /**
     * 匹配状态
     */
    @ApiModelProperty(value = "匹配状态")
    private Integer matchStatus;

    /**
     * 匹配信息
     */
    @ApiModelProperty(value = "匹配信息")
    private String  matchMsg;


    /**
     * 匹配人脸 ID
     */
    @ApiModelProperty(value = "匹配人脸 ID")
    private Integer  matchFaceId;

    /**
     * 图片地址
     */
    @ApiModelProperty(value = "图片地址")
    private String faceImage;

    /**
     * 记录时间
     */

    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "记录时间")
    private Date recordTime;

    /**
     * 是否有效数据
     */
    @ApiModelProperty(value = "是否有效数据")
    private Boolean isEffective;

    /**
     * 是否删除
     */
    @ApiModelProperty(value = "是否删除")
    private Boolean delFlag;

    /**
     * 创建人
     */
    @ApiModelProperty(value = "创建人")
    private String createBy;

    /**
     * 创建时间
     */
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;

    /**
     * 更新人
     */
    @ApiModelProperty(value = "更新人")
    private String  updateBy;

    /**
     * 更新时间
     */

    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;

    /**
     * 关联用户是否状态
     */
    @ApiModelProperty(value = "关联用户是否删除")
    private Boolean personFlag;

    @ApiModelProperty(value = "备注")
    private String remark;

}
