package com.jpsoft.shinestar.modules.base.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
  描述:base_person_device_relation的实体类
 */
@Data
@ApiModel(value = "base_person_device_relation的实体类")
public class PersonDeviceRelation {
	/**
	 *ID
	 */
        @ApiModelProperty(value = "ID")
	private String id;
	/**
	 *设备ID
	 */
        @ApiModelProperty(value = "设备ID")
	private String deviceId;

	@ApiModelProperty(value = "设备信息")
	private DeviceInfo deviceInfo;
	/**
	 *人员ID
	 */
        @ApiModelProperty(value = "人员ID")
	private Long personId;

	@ApiModelProperty(value = "人员信息")
	private PersonInfo personInfo;
	/**
	 *图片已写入设备
	 */
	@ApiModelProperty(value = "图片已写入设备")
	private Boolean isWrite;
	/**
	 *是否删除
	 */
        @ApiModelProperty(value = "是否删除")
	private Boolean delFlag;
	/**
	 *创建人
	 */
        @ApiModelProperty(value = "创建人")
	private String createBy;
	/**
	 *创建时间
	 */
    	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "创建时间")
	private Date createTime;
	/**
	 *更新人
	 */
        @ApiModelProperty(value = "更新人")
	private String updateBy;
	/**
	 *更新时间
	 */
    	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "更新时间")
	private Date updateTime;

	public DeviceInfo getDeviceInfo() {
		return deviceInfo;
	}

	public void setDeviceInfo(DeviceInfo deviceInfo) {
		this.deviceInfo = deviceInfo;
	}

	public PersonInfo getPersonInfo() {
		return personInfo;
	}

	public void setPersonInfo(PersonInfo personInfo) {
		this.personInfo = personInfo;
	}

	/**
	 *人脸信息是否绑定到终端
	 */
	@ApiModelProperty(value = "人脸信息是否绑定到终端")
	private Boolean isBound;

	@ApiModelProperty(value = "是否拥有远程开门权限")
	private Boolean remoteOpen;

}