package com.jpsoft.shinestar.modules.base.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 描述:base_person_health_ledger的实体类
 */
@Data
@ApiModel(value = "base_person_health_ledger的实体类")
public class PersonHealthLedger implements Serializable {
    /**
     *
     */
    @ApiModelProperty(value = "")
    private String id;
    /**
     * 学生ID
     */
    @ApiModelProperty(value = "学生ID")
    private Long personId;
    /**
     * 学生信息
     */
    @ApiModelProperty(value = "学生信息")
    private PersonInfo personInfo;
    /**
     * 健康情况:字典
     */
    @ApiModelProperty(value = "健康情况:字典")
    private String healthStatus;
    /**
     * 健康情况翻译
     */
    @ApiModelProperty(value = "健康情况:字典")
    private String healthStatusN;
    /**
     * 健康情况其他,输入内容
     */
    @ApiModelProperty(value = "健康情况其他,输入内容")
    private String healthRemark;
    /**
     * 家庭健康情况
     */
    @ApiModelProperty(value = "家庭健康情况")
    private String familyStatus;
    /**
     * 家庭健康情况翻译
     */
    @ApiModelProperty(value = "家庭健康情况翻译")
    private String familyStatusN;
    /**
     * 家庭健康码
     */
    @ApiModelProperty(value = "家庭健康码")
    private String familyGreenCode;
    /**
     * 是否前往疫区
     */
    @ApiModelProperty(value = "是否前往疫区")
    private Boolean isGoto;
    /**
     * 是否接触高危人员
     */
    @ApiModelProperty(value = "是否接触高危人员")
    private Boolean isTouch;
    /**
     * 是否删除
     */
    @ApiModelProperty(value = "是否删除")
    private Boolean delFlag;
    /**
     * 创建人
     */
    @ApiModelProperty(value = "创建人")
    private String createBy;
    /**
     * 创建时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 更新人
     */
    @ApiModelProperty(value = "更新人")
    private String updateBy;
    /**
     * 更新时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;

    /**
     * 健康情况备注
     */
    @ApiModelProperty(value = "备注")
    private String remark;

    /**
     * 记录温度
     */
    @ApiModelProperty(value = "记录温度")
    private BigDecimal temperature;

    /**
     * 经度
     */
    @ApiModelProperty(value = "经度")
    private String longitude;

    /**
     * 纬度
     */
    @ApiModelProperty(value = "纬度")
    private String latitude;

    @ApiModelProperty(value = "地址")
    private String address;

    @ApiModelProperty(value = "是否荆州过年 1在， 0不在")
    private Boolean isJingzhou;

    @ApiModelProperty(value = "是否外省 1外省，0内省")
    private Boolean isProvince;

    @ApiModelProperty(value = "连续打卡天数")
    private Integer countNum;
}