package com.jpsoft.shinestar.modules.base.entity;

import java.util.Date;
import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.constraints.NotBlank;
import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
  描述:base_person_phone_book的实体类
 */
@Data
@ApiModel(value = "base_person_phone_book的实体类")
public class PersonPhoneBook {
    @ApiModelProperty(value = "")
    private String id;
    @ApiModelProperty(value = "电话簿的拥有者ID")
    private Long personId;

    @NotBlank(message = "姓名不能为空!")
    @Length(max=10,message = "姓名不能超过10个字符")
    @ApiModelProperty(value = "联系人姓名")
    private String name;

    @NotBlank(message = "号码不能为空!")
    @Length(max=11,message = "号码位数不能超过11位")
    @ApiModelProperty(value = "联系人电话")
    private String phone;

    @ApiModelProperty(value = "是否删除")
    private Boolean delFlag;
    @ApiModelProperty(value = "创建人")
    private String createBy;
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    @ApiModelProperty(value = "更新人")
    private String updateBy;
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;
    @ApiModelProperty(value = "是否为紧急联系人")
    private Boolean urgentStatus;

}