package com.jpsoft.shinestar.modules.base.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;

import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
 * 描述:base_person_popedom的实体类
 */
@Data
@ApiModel(value = "base_person_popedom的实体类")
public class PersonPopedom {
    @ApiModelProperty(value = "")
    private String id;
    @ApiModelProperty(value = "对应公司id")
    private String companyId;
    @ApiModelProperty(value = "机构ID")
    private String companyStructureId;
    @ApiModelProperty(value = "对应角色id")
    private String personRoleId;
    @ApiModelProperty(value = "人员id")
    private Long personId;
    @ApiModelProperty(value = "展示的图标id")
    private String showIconId;
    @ApiModelProperty(value = "是否删除")
    private Boolean delFlag;
    @ApiModelProperty(value = "创建人")
    private String createBy;
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    @ApiModelProperty(value = "更新人")
    private String updateBy;
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;
    @ApiModelProperty(value = "备注信息")
    private String remark;
    @ApiModelProperty(value = "单位翻译")
    private String companyName;
    @ApiModelProperty(value = "机构翻译")
    private String companyStructureName;
    @ApiModelProperty(value = "角色翻译")
    private String roleName;
    @ApiModelProperty(value = "用户默认关系")
    private Boolean isDefault;
    @ApiModelProperty(value = "地址")
    private String address;
    @ApiModelProperty(value = "被关联者id")
    private String relationPopedom;
    @ApiModelProperty(value = "关系名称")
    private String relationName;
    @ApiModelProperty(value = "服务公司")
    private String serviceCompanyId;
    @ApiModelProperty(value = "场景值ID")
    private String sceneId;
    @ApiModelProperty(value = "推广者id")
    private Long popularizePersonId;
    @ApiModelProperty(value = "推广者姓名")
    private String popularizePersonName;
    @ApiModelProperty(value = "能否进行注册审核")
    private Boolean enableRegisterExamine = false;
    @ApiModelProperty(value = "是否纳入考勤")
    private Boolean enableAttendance = false;
    @ApiModelProperty(value = "姓名")
    private String personName;
    @ApiModelProperty(value = "照片")
    private String faceImageUrl;
    @ApiModelProperty(value = "加班工时")
    private Integer workOverTime = 0;
}