package com.jpsoft.shinestar.modules.base.entity;

import java.util.Date;
import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
 * 描述:base_person_role_icon的实体类
 */
@Data
@ApiModel(value = "base_person_role_icon的实体类")
public class PersonRoleIcon {
    @ApiModelProperty(value = "")
    private String id;

    @ApiModelProperty(value = "用户角色id")
    private String personRoleId;

    @ApiModelProperty(value = "图标id")
    private String iconId;

    @ApiModelProperty(value = "是否通用")
    private Boolean commonStatus = false;

    @ApiModelProperty(value = "是否默认")
    private Boolean defaultStatus = false;

    @ApiModelProperty(value = "是否删除")
    private Boolean delFlag = false;

    @ApiModelProperty(value = "创建人")
    private String createBy;

    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;

    @ApiModelProperty(value = "更新人")
    private String updateBy;

    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;

    @ApiModelProperty(value = "备注信息")
    private String remark;

    @ApiModelProperty(value = "图标名称")
    private String iconName;

    @ApiModelProperty(value = "排序号")
    private Integer sortNo;
}