package com.jpsoft.shinestar.modules.base.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;
import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
  描述:base_person_role_info的实体类
 */
@Data
@ApiModel(value = "base_person_role_info的实体类")
public class PersonRoleInfo {
	@ApiModelProperty(value = "")
	private String id;
	@ApiModelProperty(value = "用户角色名称")
	private String personRoleName;
	@ApiModelProperty(value = "适用于与场景id")
	private String sceneId;
	@ApiModelProperty(value = "适用于与场景翻译")
	private String sceneName;
	@ApiModelProperty(value = "是否启用")
	private Boolean useEnable;
	@ApiModelProperty(value = "备注")
	private String remark;
	@ApiModelProperty(value = "创建人")
	private String createBy;
	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	@ApiModelProperty(value = "创建时间")
	private Date createTime;
	@ApiModelProperty(value = "更新人")
	private String updateBy;
	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	@ApiModelProperty(value = "更新时间")
	private Date updateTime;
	@ApiModelProperty(value = "是否删除")
	private Boolean delFlag;
	@ApiModelProperty(value = "图标")
	private String pic;
	@ApiModelProperty(value = "能否注册")
	private Boolean registerEnable = false;
	@ApiModelProperty(value = "上级编号")
	private String parentId;
	@ApiModelProperty(value = "上级名称")
	private String parentName;
}