package com.jpsoft.shinestar.modules.base.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * 描述:base_punch_record的实体类
 */
@Data
@ApiModel(value = "base_punch_record的实体类")
public class PunchRecord {
    /**
     *
     */
    @ApiModelProperty(value = "")
    private String id;
    /**
     * 打卡人ID
     */
    @ApiModelProperty(value = "打卡人ID")
    private Long personId;
    /**
     * 打卡点ID
     */
    @ApiModelProperty(value = "打卡点ID")
    private String punchId;
    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    private String remark;
    /**
     * 当前经度
     */
    @ApiModelProperty(value = "当前经度")
    private String longtitude;
    /**
     * 当前维度
     */
    @ApiModelProperty(value = "当前维度")
    private String latitude;
    /**
     * 是否删除
     */
    @ApiModelProperty(value = "是否删除")
    private Boolean delFlag;
    /**
     * 创建人
     */
    @ApiModelProperty(value = "创建人")
    private String createBy;
    /**
     * 创建时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 更新人
     */
    @ApiModelProperty(value = "更新人")
    private String updateBy;
    /**
     * 更新时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;
}