package com.jpsoft.shinestar.modules.base.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;

import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
 * 描述:base_return_info的实体类
 */
@Data
@ApiModel(value = "base_return_info的实体类")
public class ReturnInfo implements Serializable{
    @ApiModelProperty(value = "")
    private String id;
    @ApiModelProperty(value = "登记人姓名")
    private String name;
    @ApiModelProperty(value = "openid")
    private String openId;
    @ApiModelProperty(value = "身份证号码")
    private String idCard;
    @ApiModelProperty(value = "手机号码")
    private String phone;
    @ApiModelProperty(value = "居住地区id")
    private String liveRegionId;
    @ApiModelProperty(value = "居住地区翻译")
    private String liveRegionN;
    @ApiModelProperty(value = "居住地详细地址")
    private String liveDetailAddress;
    @ApiModelProperty(value = "始发地")
    private String originId;
    @ApiModelProperty(value = "始发地翻译")
    private String originN;
    @ApiModelProperty(value = "始发地详细地址")
    private String originDetailAddress;
    @ApiModelProperty(value = "途径地")
    private String avenuePlace;
    @ApiModelProperty(value = "交通工具")
    private String vehicle;
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @ApiModelProperty(value = "返乡时间")
    private Date arriveTime;
    @ApiModelProperty(value = "7日阴性核酸检测")
    private Boolean haveCheck;
    @ApiModelProperty(value = "备注")
    private String remark;
    @ApiModelProperty(value = "核酸检测报告图片")
    private String checkImageUrl;
    @ApiModelProperty(value = "行程卡图片")
    private String travelImageUrl;
    @ApiModelProperty(value = "健康码图片")
    private String healthCodeUrl;
    @ApiModelProperty(value = "是否删除")
    private Boolean delFlag;
    @ApiModelProperty(value = "创建人")
    private String createBy;
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    @ApiModelProperty(value = "更新人")
    private String updateBy;
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;
    private String haveCheckStr;
    @ApiModelProperty(value = "返乡类型")
    private String type;
    @ApiModelProperty(value = "返乡类型翻译")
    private String typeN;
    private Boolean enableUpdate = true;
    private Boolean newFlag = true;
}