package com.jpsoft.shinestar.modules.base.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * @author 墨鱼_mo
 * @date 2020-7-27 14:12
 */
@Data
public class SchoolServe {

    private String id;

    @ApiModelProperty(value = "学校id")
    private String companyId;
    @ApiModelProperty(value = "单位名称")
    private String companyName;

    @ApiModelProperty(value = "字典id")
    private String dictionaryId;
    @ApiModelProperty(value = "字典翻译")
    private String dictionaryName;

    @ApiModelProperty(value = "是否启用")
    private Boolean status = true;

    /**
     *是否删除
     */
    @ApiModelProperty(value = "是否删除")
    private Boolean delFlag = false;
    /**
     *创建人
     */
    @ApiModelProperty(value = "创建人")
    private String createBy;
    /**
     *创建时间
     */
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     *更新人
     */
    @ApiModelProperty(value = "更新人")
    private String updateBy;
    /**
     *更新时间
     */
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;


    @ApiModelProperty(value = "分享文章标题")
    private String shareTitle;
    @ApiModelProperty(value = "分享文章图片")
    private String shareImg;
    @ApiModelProperty(value = "分享文章描述")
    private String shareDescription;

}
