package com.jpsoft.shinestar.modules.base.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.util.Date;

/**
  描述:base_warning_pusher的实体类
 */
@Data
@ApiModel(value = "base_warning_pusher的实体类")
public class WarningPusher {
	/**
	 *编号
	 */
        @ApiModelProperty(value = "编号")
	private String id;
	/**
	 *所属公司编号
	 */
        @ApiModelProperty(value = "所属公司编号")
	private String companyId;

	/**
	 *所属公司编号
	 */
	@ApiModelProperty(value = "所属公司名称")
	private String companyName;
	/**
	 *最大测温次数
	 */
        @ApiModelProperty(value = "最大测温次数")
	private Integer times;
	/**
	 *预警温度
	 */
        @ApiModelProperty(value = "预警温度")
	private BigDecimal temperature;
	/**
	 *姓名
	 */
        @ApiModelProperty(value = "姓名")
	private String name;
	/**
	 *手机号
	 */
        @ApiModelProperty(value = "手机号")
	private String phone;
	/**
	 *微信openId
	 */
        @ApiModelProperty(value = "微信openId")
	private String openId;
	/**
	 *备注
	 */
        @ApiModelProperty(value = "备注")
	private String remark;
	/**
	 *是否删除
	 */
        @ApiModelProperty(value = "是否删除")
	private Boolean delFlag;
	/**
	 *创建人
	 */
        @ApiModelProperty(value = "创建人")
	private String createBy;
	/**
	 *创建时间
	 */
    	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "创建时间")
	private Date createTime;
	/**
	 *更新人
	 */
        @ApiModelProperty(value = "更新人")
	private String updateBy;
	/**
	 *更新时间
	 */
	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	@ApiModelProperty(value = "更新时间")
	private Date updateTime;
	/**
	 * 未测温提醒
	 */
	@ApiModelProperty(value = "未测温提醒")
	private Boolean missingNoticeEnabled;
}