package com.jpsoft.shinestar.modules.base.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;

import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
 * 描述:base_watch_info的实体类
 */
@Data
@ApiModel(value = "base_watch_info的实体类")
public class WatchInfo {
    /**
     * 编号
     */
    @ApiModelProperty(value = "编号")
    private String id;
    @ApiModelProperty(value = "人员id")
    private Long personId;
    /**
     * 设备编号
     */
    @ApiModelProperty(value = "设备编号")
    private String deviceNo;
    /**
     * 设备别名
     */
    @ApiModelProperty(value = "设备别名")
    private String aliasName;
    /**
     * 订单编号
     */
    @ApiModelProperty(value = "订单编号")
    private String orderNo;
    /**
     * 默认设备（是/否）
     */
    @ApiModelProperty(value = "默认设备（是/否）")
    private Boolean isDefault;
    /**
     * 心跳更新时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "心跳更新时间")
    private Date heartBeatUpdateTime;
    /**
     * 运行状态（是否在线）
     */
    @ApiModelProperty(value = "运行状态（是否在线）")
    private Boolean isOnline;
    /**
     * 紧急联系人号码
     */
    @ApiModelProperty(value = "紧急联系人号码")
    private String sos1;
    /**
     * 紧急联系人号码
     */
    @ApiModelProperty(value = "紧急联系人号码")
    private String sos2;
    /**
     * 紧急联系人号码
     */
    @ApiModelProperty(value = "紧急联系人号码")
    private String sos3;
    /**
     * 计步器开关
     */
    @ApiModelProperty(value = "计步器开关")
    private Boolean stepSwitch;
    /**
     * 定位间隔时间
     */
    @ApiModelProperty(value = "定位间隔时间")
    private String locationTimeInterval;
    /**
     * 心率间隔时间
     */
    @ApiModelProperty(value = "心率间隔时间")
    private String heartRateTimeInterval;
    /**
     * 定位间隔时间
     */
    @ApiModelProperty(value = "血氧间隔时间")
    private String bloodOxygenInterval;
    /**
     * 血压间隔时间
     */
    @ApiModelProperty(value = "血压间隔时间")
    private String bpi;
    /**
     * 最大心率阀值
     */
    @ApiModelProperty(value = "最大心率阀值")
    private String heartRateMax;
    /**
     * 最小心率阀值
     */
    @ApiModelProperty(value = "最小心率阀值")
    private String heartRateMin;
    /**
     * 最大收缩压阀值
     */
    @ApiModelProperty(value = "最大收缩压阀值")
    private String bpHighMax;
    /**
     * 最小收缩压阀值
     */
    @ApiModelProperty(value = "最小收缩压阀值")
    private String bpHighMin;
    /**
     * 最大舒张压阀值
     */
    @ApiModelProperty(value = "最大舒张压阀值")
    private String bpLowMax;
    /**
     * 最小舒张压阀值
     */
    @ApiModelProperty(value = "最小舒张压阀值")
    private String bpLowMin;
    /**
     * 最大血氧阀值
     */
    @ApiModelProperty(value = "最大血氧阀值")
    private String bloodOxMax;
    /**
     * 最小血氧阀值
     */
    @ApiModelProperty(value = "最小血氧阀值")
    private String bloodOxMin;
    /**
     * 服务号码
     */
    @ApiModelProperty(value = "服务号码")
    private String num1;
    @ApiModelProperty(value = "最低温度")
    private String tempMin;
    @ApiModelProperty(value = "服务号码")
    private Integer frequency;
    /**
     * 是否删除
     */
    @ApiModelProperty(value = "是否删除")
    private Boolean delFlag;
    /**
     * 创建人
     */
    @ApiModelProperty(value = "创建人")
    private String createBy;
    /**
     * 创建时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 更新人
     */
    @ApiModelProperty(value = "更新人")
    private String updateBy;
    /**
     * 更新时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;
    /**
     * 最后定位位置
     */
    private String latestLocation;
}