package com.jpsoft.shinestar.modules.base.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;
import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
  描述:人员每日班次管理
 */
@Data
@ApiModel(value = "base_work_person_scheduling的实体类")
public class WorkPersonScheduling {
        @ApiModelProperty(value = "编号")
    private String id;
        @ApiModelProperty(value = "人员id")
    private Long personId;
        @ApiModelProperty(value = "年")
    private Integer year;
        @ApiModelProperty(value = "月")
    private Integer month;
        @ApiModelProperty(value = "日")
    private Integer day;
        @DateTimeFormat(pattern="yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd",timezone ="GMT+8")
	    @ApiModelProperty(value = "安排日期")
    private Date schedulingDay;
        @ApiModelProperty(value = "班次ID,多逗号分隔")
    private String shiftIds;
        @ApiModelProperty(value = "班次编号,多逗号分隔")
    private String shiftNumbers;
        @ApiModelProperty(value = "创建人")
    private String createBy;
        @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "创建时间")
    private Date createTime;
        @ApiModelProperty(value = "更新人")
    private String updateBy;
        @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "更新时间")
    private Date updateTime;
        @ApiModelProperty(value = "是否删除")
    private Boolean delFlag = false;
}