package com.jpsoft.shinestar.modules.business.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;
import java.util.List;

@Data
public class BillPushDetailListDTO {

    @ApiModelProperty(value = "ID")
    private String id;

    @ApiModelProperty(value = "账单名称")
    private String name;

    @ApiModelProperty(value = "收款方")
    private String payee;

    @ApiModelProperty(value = "收款账户")
    private String collectionAccount;

    @ApiModelProperty(value = "缴费单位")
    private String companyName;

    @ApiModelProperty(value = "推送用户")
    private String personName;


    @ApiModelProperty(value = "推送状态")
    private String status;

    @ApiModelProperty(value = "推送时间")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    private Date pushTime;

    @ApiModelProperty(value = "支付方式")
    private String payName;

    @ApiModelProperty(value = "支付状态")
    private Integer payStatus;

    @ApiModelProperty(value = "支付时间")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    private Date payTime;

    @ApiModelProperty(value = "收款人")
    private String payeePerson;

    @ApiModelProperty(value = "备注")
    private String bak;

    @ApiModelProperty(value = "微信支付")
    private Boolean isOpenWechat;

    @ApiModelProperty(value = "支付宝支付")
    private Boolean isOpenAlipay;

    @ApiModelProperty(value = "开票类型")
    private String invoiceType;

    @ApiModelProperty(value = "开票类型")
    private String invoiceTypeN;

    @ApiModelProperty(value = "订单ID")
    private String orderId;

    @ApiModelProperty(value = "是否能开启手机支付")
    private Boolean isMobilePayment;

    @ApiModelProperty(value = "是否开票")
    private Boolean invoiced;
}
