package com.jpsoft.shinestar.modules.business.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.util.Date;

@Data
public class BillPushGoodStatisticsDTO {

    @ApiModelProperty(value = "缴费单位")
    private String companyName;

    @ApiModelProperty(value = "收费项目")
    private String goodsName;

    @ApiModelProperty(value = "起止时间")
    private String beginEndTime;

    @ApiModelProperty(value = "合计金额")
    private BigDecimal totalFee;

    @ApiModelProperty(value = "是否开票")
    private Boolean invoiced;

    @ApiModelProperty(value = "开票类型")
    private String invoiceType;

    @ApiModelProperty(value = "缴费状态")
    private Integer payStatus;

    @ApiModelProperty(value = "收款账户")
    private String collectionAccount;

    @ApiModelProperty(value = "支付时间")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    private Date payTime;

    @ApiModelProperty(value = "收款方")
    private String payee;
}
