package com.jpsoft.shinestar.modules.business.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

@Data
public class CarryThingsOutFactoryDTO {

    @ApiModelProperty(value = "编号")
    private String id;

    @ApiModelProperty(value = "人员姓名")
    private String personName;

    @ApiModelProperty(value = "出厂日期")
    @DateTimeFormat(pattern="yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd",timezone ="GMT+8")
    private Date leaveFactoryTime;

    @ApiModelProperty(value = "提交时间")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    private Date createTime;

    @ApiModelProperty(value = "审核状态（0：审核中，1：同意，2：退回，3：拒绝，4：无需审核）")
    private String auditStatus;

    @ApiModelProperty(value = "申请理由以及出产清单")
    private String leaveFactoryReason;

    @ApiModelProperty(value = "图片")
    private String image;
    @ApiModelProperty(value = "审核状态")
    private String auditStatusName;

    @ApiModelProperty(value = "放行人")
    private String releasePerson;

    @ApiModelProperty(value = "放行人所属部门")
    private String releaseCompany;

    @ApiModelProperty(value = "放行时间")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    private Date releaseTime;
}
