package com.jpsoft.shinestar.modules.business.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import io.swagger.annotations.ApiModelProperty;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

@Data
public class GuestRecordAddDTO {

    @ApiModelProperty(value = "来访人姓名")
    private String name;

    @ApiModelProperty(value = "来访人电话")
    private String mobilePhone;

    @ApiModelProperty(value = "来访人单位")
    private String unit;

    @ApiModelProperty(value = "来访人事由")
    private String visitReasons;

    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "来访日期")
    private Date visitDate;

    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "过期时间")
    private Date expirationTime;

    @ApiModelProperty(value = "下发设备ID（多个设备ID以逗号隔开）")
    private String issueDevice;

    @ApiModelProperty(value = "是否上传登记照")
    private Boolean isUpPhoto;
}
