package com.jpsoft.shinestar.modules.business.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

@Data
public class MedicalPersonDTO {

    @ApiModelProperty(value = "id")
    private String id;

    @ApiModelProperty(value = "人员ID")
    private Long personId;

    @ApiModelProperty(value = "人脸相片地址")
    private String faceImageUrl;

    @ApiModelProperty(value = "姓名")
    private String name;

    @ApiModelProperty(value = "性别")
    private String gender;

    @DateTimeFormat(pattern="yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd",timezone ="GMT+8")
    @ApiModelProperty(value = "出生年月")
    private Date birthDate;

    @ApiModelProperty(value = "过敏药品")
    private String allergicDrugs;

    @ApiModelProperty(value = "已有病史")
    private String medicalHistory;
}
