package com.jpsoft.shinestar.modules.business.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * @author 墨鱼_mo
 * @date 2021-4-27 15:00
 */
@Data
public class AdjustShift {

    private String id;

    @ApiModelProperty(value = "人员角色id")
    private String personPopedomId;

    @ApiModelProperty(value = "流程实例编号")
    private String procinstId;

    @ApiModelProperty(value = "调整的排班记录id")
    private String schedulingId;

    @ApiModelProperty(value = "调整日期")
    private String adjustDate;

    @ApiModelProperty(value = "调整后的班次id")
    private String newShiftId;

    @ApiModelProperty(value = "调整后的班次编号")
    private String newShiftNumber;

    @ApiModelProperty(value = "调整前的班次id")
    private String oldShiftId;

    @ApiModelProperty(value = "备注")
    private String remark;

    @ApiModelProperty(value = "审核类型（1：个人申请，2：上级安排）")
    private String type;

    @ApiModelProperty(value = "审核状态（0：审核中，1：同意，2：退回，3：拒绝，4：无需审核）")
    private String status;

    /**
     *提交时间
     */
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "提交时间")
    private Date submitTime;

    /**
     *创建人
     */
    @ApiModelProperty(value = "创建人")
    private String createBy;
    /**
     *创建时间
     */
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     *更新人
     */
    @ApiModelProperty(value = "更新人")
    private String updateBy;
    /**
     *更新时间
     */
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;
    /**
     *是否删除
     */
    @ApiModelProperty(value = "是否删除")
    private Boolean delFlag = false;

    private String personName;
    private String jobNumber;
    private String companyName;
    private String oldShiftName;
    private String newShiftName;
    private String statusN;

}
