package com.jpsoft.shinestar.modules.business.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * @author 墨鱼_mo
 * @date 2021-4-27 15:35
 */
@Data
public class AdjustShiftPerson {

    private String id;

    @ApiModelProperty(value = "调排班主表id")
    private String adjustShiftId;


    @ApiModelProperty(value = "调整的排班记录id")
    private String schedulingId;


    @ApiModelProperty(value = "人员角色id")
    private String personPopedomId;


    @ApiModelProperty(value = "调整后的班次id")
    private String newShiftId;

    @ApiModelProperty(value = "调整后的班次编号")
    private String newShiftNumber;

    @ApiModelProperty(value = "调整前的班次id")
    private String oldShiftId;

    /**
     *创建人
     */
    @ApiModelProperty(value = "创建人")
    private String createBy;
    /**
     *创建时间
     */
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     *更新人
     */
    @ApiModelProperty(value = "更新人")
    private String updateBy;
    /**
     *更新时间
     */
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;
    /**
     *是否删除
     */
    @ApiModelProperty(value = "是否删除")
    private Boolean delFlag = false;
}
