package com.jpsoft.shinestar.modules.business.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
  描述:business_bill_push的实体类
 */
@Data
public class BillPush {
	private String id;
	private String name;
	private String bak;
	private String collectionAccountId;
	private String payService;

	@ApiModelProperty(value = "推送时间")
	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	private Date pushTime;

	private String companyId;
	private String payee;
	private Boolean delFlag;
	private String createBy;

	@ApiModelProperty(value = "创建时间")
	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	private Date createTime;
	private String updateBy;

	@ApiModelProperty(value = "更新时间")
	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	private Date updateTime;
	private Long personId;
	private String orderId;
	private String status;
	private String checkinInfoId;

	private Boolean isOpenWechat = false;
	private Boolean isOpenAlipay = false;

	@ApiModelProperty(value = "开票类型")
	private String invoiceType;

	@ApiModelProperty(value = "是否开票")
	private Boolean invoiced;
}