package com.jpsoft.shinestar.modules.business.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;
import java.util.List;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
  描述:business_carry_things_out_factory的实体类
 */
@Data
@ApiModel(value = "business_carry_things_out_factory的实体类")
public class CarryThingsOutFactory {

	@ApiModelProperty(value = "编号")
	private String id;

	@ApiModelProperty(value = "人员身份ID")
	private String personPopedomId;

	@ApiModelProperty(value = "出厂日期")
	@DateTimeFormat(pattern="yyyy-MM-dd")
	@JsonFormat(pattern = "yyyy-MM-dd",timezone ="GMT+8")
	private Date leaveFactoryTime;

	@ApiModelProperty(value = "申请理由以及出产清单")
	private String leaveFactoryReason;

	@ApiModelProperty(value = "图片")
	private String image;

	@ApiModelProperty(value = "审核状态（0：审核中，1：同意，2：退回，3：拒绝，4：无需审核）")
	private String auditStatus;

	@ApiModelProperty(value = "放行人")
	private String releaseBy;

	@ApiModelProperty(value = "放行人")
	private String releaseByN;

	@ApiModelProperty(value = "放行状态")
	private String releaseStatus = "0";

	@ApiModelProperty(value = "放行时间")
	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	private Date releaseTime;

	@ApiModelProperty(value = "创建人")
	private String createBy;

	@ApiModelProperty(value = "创建时间")
	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	private Date createTime;

	@ApiModelProperty(value = "更新人")
	private String updateBy;

	@ApiModelProperty(value = "更新时间")
	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	private Date updateTime;

	@ApiModelProperty(value = "是否删除")
	private Boolean delFlag = false;

	@ApiModelProperty(value = "流程实例编号")
	private String procinstId;


	@ApiModelProperty(value = "人员姓名")
	private String personName;
	@ApiModelProperty(value = "工号")
	private String jobNumber;
	@ApiModelProperty(value = "部门")
	private String companyName;
	@ApiModelProperty(value = "审批人")
	private String auditByN;
	@ApiModelProperty(value = "审核状态（0：审核中，1：同意，2：退回，3：拒绝，4：无需审核）")
	private String auditStatusN;

	@ApiModelProperty(value = "审批时间")
	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	private Date auditTime;

	private List<String> imageList;

}