package com.jpsoft.shinestar.modules.workflow.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;
import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
  描述:wf_process_act_user的实体类
 */
@Data
@ApiModel(value = "wf_process_act_user的实体类")
public class ProcessActUser {
	/**
	 *步骤审批人编号
	 */
        @ApiModelProperty(value = "步骤审批人编号")
	private String id;
	/**
	 *步骤编号
	 */
        @ApiModelProperty(value = "步骤编号")
	private String activityId;
	/**
	 *用户类型(1-审批用户、2-抄送用户)
	 */
        @ApiModelProperty(value = "用户类型(1-审批用户、2-抄送用户)")
	private String userType;
	/**
	 *审批人编号
	 */
        @ApiModelProperty(value = "审批人编号")
	private String personId;
	/**
	 *部门编号
	 */
        @ApiModelProperty(value = "部门编号")
	private String departmentId;
	/**
	 *人员角色编号
	 */
        @ApiModelProperty(value = "人员角色编号")
	private String personRoleId;
	/**
	 *相对职位（1-直属领导）
	 */
        @ApiModelProperty(value = "相对职位（1-直属领导）")
	private String relativePosition;
	/**
	 *创建人
	 */
        @ApiModelProperty(value = "创建人")
	private String createBy;
	/**
	 *创建时间
	 */
    	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "创建时间")
	private Date createTime;
	/**
	 *更新人
	 */
        @ApiModelProperty(value = "更新人")
	private String updateBy;
	/**
	 *更新时间
	 */
    	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "更新时间")
	private Date updateTime;
	/**
	 *是否删除
	 */
        @ApiModelProperty(value = "是否删除")
	private Boolean delFlag;

	/**
	 *来源（1-手工指定、2-固定部门+角色、3-相对职位）
	 */
	@ApiModelProperty(value = "来源（1-手工指定、2-固定部门+角色、3-相对职位）")
	private String source;
}