package com.jpsoft.shinestar.modules.workflow.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;
import java.util.List;

import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
  描述:wf_process_activity的实体类
 */
@Data
@ApiModel(value = "wf_process_activity的实体类")
public class ProcessActivity {
	/**
	 *步骤编号
	 */
        @ApiModelProperty(value = "步骤编号")
	private String id;
	/**
	 *步骤序号
	 */
        @ApiModelProperty(value = "步骤序号")
	private Integer activityOrder;
	/**
	 *流程模板编号
	 */
        @ApiModelProperty(value = "流程模板编号")
	private String processTemplateId;
	/**
	 *步骤名称
	 */
        @ApiModelProperty(value = "步骤名称")
	private String name;
	/**
	 *
	 */
        @ApiModelProperty(value = "")
	private String remark;

	@ApiModelProperty(value = "流程步骤角色")
	private String personRoleId;
	/**
	 *审批方式（or-如果多个人，则只要一个人审批）
	 */
        @ApiModelProperty(value = "审批方式（or-如果多个人，则只要一个人审批）")
	private String operation;
	/**
	 *创建人
	 */
        @ApiModelProperty(value = "创建人")
	private String createBy;
	/**
	 *创建时间
	 */
    	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "创建时间")
	private Date createTime;
	/**
	 *更新人
	 */
        @ApiModelProperty(value = "更新人")
	private String updateBy;
	/**
	 *更新时间
	 */
    	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "更新时间")
	private Date updateTime;
	/**
	 *是否删除
	 */
        @ApiModelProperty(value = "是否删除")
	private Boolean delFlag;

	@ApiModelProperty(value = "抄送人ID")
	private List<String> ccPersonIdList;

	@ApiModelProperty(value = "审批人ID")
	private List<String>  approvedPersonIdList;

	@ApiModelProperty(value = "部门名称")
	private String companyName;

	@ApiModelProperty(value = "角色名称")
	private String roleName;


	@ApiModelProperty(value = "抄送人数组")
	private String[] ccPersonIdArray;

	@ApiModelProperty(value = "审批人数组")
	private String[]  approvedPersonIdArray;

	@ApiModelProperty(value = "部门ID")
	private String  companyId;

	@ApiModelProperty(value = "角色ID")
	private String  roleId;

	@ApiModelProperty(value = "相对职位（1-直属领导）")
	private String relativePosition;

	@ApiModelProperty(value = "步骤执行条件")
	private String condition;

	private String source;


}