package com.jpsoft.shinestar.modules.workflow.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;
import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
  描述:wf_process_set的实体类
 */
@Data
@ApiModel(value = "wf_process_set的实体类")
public class ProcessSet {
	/**
	 *流程集编号
	 */
        @ApiModelProperty(value = "流程集编号")
	private String id;
	/**
	 *流程集KEY
	 */
	@ApiModelProperty(value = "流程集KEY")
	private String proKey;
	/**
	 *流程集名称
	 */
        @ApiModelProperty(value = "流程集名称")
	private String name;
	/**
	 *备注
	 */
        @ApiModelProperty(value = "备注")
	private String remark;
	/**
	 *表单编号
	 */
        @ApiModelProperty(value = "表单编号")
	private String formId;
	/**
	 *流程分类
	 */
        @ApiModelProperty(value = "流程分类")
	private String category;
	/**
	 *单位编号
	 */
        @ApiModelProperty(value = "单位编号")
	private String companyId;
	/**
	 *创建人
	 */
        @ApiModelProperty(value = "创建人")
	private String createBy;
	/**
	 *创建时间
	 */
    	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "创建时间")
	private Date createTime;
	/**
	 *更新人
	 */
        @ApiModelProperty(value = "更新人")
	private String updateBy;
	/**
	 *更新时间
	 */
    	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "更新时间")
	private Date updateTime;
	/**
	 *是否删除
	 */
        @ApiModelProperty(value = "是否删除")
	private Boolean delFlag;

	@ApiModelProperty(value = "（状态（未激活：0，激活:1）")
	private Boolean status;
}