package com.jpsoft.shinestar.modules.workflow.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;
import java.util.List;

import com.jpsoft.shinestar.modules.base.entity.CompanyInfo;
import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
  描述:wf_process_template的实体类
 */
@Data
@ApiModel(value = "wf_process_template的实体类")
public class ProcessTemplate {
	/**
	 *流程分支编号
	 */
        @ApiModelProperty(value = "流程分支编号")
	private String id;
	/**
	 *流程集编号
	 */
        @ApiModelProperty(value = "流程集编号")
	private String processSetId;
	/**
	 *流程名称
	 */
        @ApiModelProperty(value = "流程名称")
	private String name;
	/**
	 *备注
	 */
        @ApiModelProperty(value = "备注")
	private String remark;
	/**
	 *创建人
	 */
        @ApiModelProperty(value = "创建人")
	private String createBy;
	/**
	 *创建时间
	 */
    	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "创建时间")
	private Date createTime;
	/**
	 *更新人
	 */
        @ApiModelProperty(value = "更新人")
	private String updateBy;
	/**
	 *更新时间
	 */
    	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "更新时间")
	private Date updateTime;
	/**
	 *是否删除
	 */
        @ApiModelProperty(value = "是否删除")
	private Boolean delFlag;


	@ApiModelProperty(value = "模版序号")
	private Integer sort;


    @ApiModelProperty(value = "单位数组")
    private String[] companyArray;

	@ApiModelProperty(value = "单位列表")
	private List<CompanyInfo> companyNameList;


    @ApiModelProperty(value = "流程步骤数量")
    private Integer orderNum;

}