package com.jpsoft.shinestar.modules.workflow.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;

import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
 * 描述:wf_procinst的实体类
 */
@Data
@ApiModel(value = "wf_procinst的实体类")
public class Procinst {
    /**
     * 流程实例编号
     */
    @ApiModelProperty(value = "流程实例编号")
    private String id;
    /**
     * 流程分支编号
     */
    @ApiModelProperty(value = "流程分支编号")
    private String processTemplateId;
    /**
     * 业务主键
     */
    @ApiModelProperty(value = "业务主键")
    private String businessKey;

    private Long personId;

    @ApiModelProperty(value = "1：调班，2：请假，3：出差，4：补卡，5：批量补卡，:6：加班，7：批量加班，8：携物出厂，9：接待进餐")
    private String type;

    /**
     * 创建人
     */
    @ApiModelProperty(value = "创建人")
    private String createBy;
    /**
     * 创建时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 更新人
     */
    @ApiModelProperty(value = "更新人")
    private String updateBy;
    /**
     * 更新时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;
    /**
     * 是否删除
     */
    @ApiModelProperty(value = "是否删除")
    private Boolean delFlag = false;
}