package com.jpsoft.shinestar.modules.workflow.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;

import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
 * 描述:wf_procinst_activity的实体类
 */
@Data
@ApiModel(value = "wf_procinst_activity的实体类")
public class ProcinstActivity {
    /**
     * 编号
     */
    @ApiModelProperty(value = "编号")
    private String id;
    /**
     * 流程实例编号
     */
    @ApiModelProperty(value = "流程实例编号")
    private String procinstId;
    /**
     * 步骤编号（由于存在退回，所以编号会变化）
     */
    @ApiModelProperty(value = "步骤编号（由于存在退回，所以编号会变化）")
    private Integer activityIndex;
    /**
     * 流程步骤编号
     */
    @ApiModelProperty(value = "流程步骤编号")
    private String activityId;
    /**
     * 审批动作(同意、退回、不同意)
     */
    @ApiModelProperty(value = "审批动作(同意、退回、不同意)")
    private String action;

    @ApiModelProperty(value = "状态（0：非当前操作步骤，1：当前操作步骤）")
    private String status;

    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    private String remark;
    /**
     * 完成时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "完成时间")
    private Date finishTime;
    /**
     * 创建人
     */
    @ApiModelProperty(value = "创建人")
    private String createBy;
    /**
     * 创建时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 更新人
     */
    @ApiModelProperty(value = "更新人")
    private String updateBy;
    /**
     * 更新时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;
    /**
     * 是否删除
     */
    @ApiModelProperty(value = "是否删除")
    private Boolean delFlag = false;

    private String auditPersonName;
    private String auditTime;
}