package com.jpsoft.shinestar.modules.pay.properties;

import lombok.Data;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

/**
 * @author 墨鱼_mo
 * @date 2019-11-26 9:37
 */

@Data
@ConfigurationProperties(prefix = "alipay")
@Component
public class AliPayProperties {


    /**
     * 支付宝网关
     */
    private String serviceUrl;

    /**
     * 应用appid
     */
    private String appId;

    /**
     * 应用私钥
     */
    private String privateKey;

    /**
     * 支付宝公钥
     */
    private String zfbPublicKey;

    /**
     * 编码
     */
    private String inputCharset;

    /**
     * 服务商id
     */
    private String mchId;

    /**
     * 授权token
     */
    private String appAuthToken;

    /**
     * 加密方式
     */
    private String signType;

    /**
     * 支付回调地址
     */
    private String notifyUrl;

    /**
     * 商品描述
     */
    private String body;
}
